/*
 * debug.c
 *
 *  Created on: 08.10.2010
 *      Author: mkriegel
 */

#include "debug.h"

/*****************************************************************************************************************************************/
inline void InitDebugUSART ()
{
	DEBUG_PORT.DIRSET = (1 << PIN3);
	DEBUG_PORT.DIRCLR = (1 << PIN2);
	USART_Format_Set	(&DEBUG, USART_CMODE_ASYNCHRONOUS_gc, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 0);
	USART_Baudrate_Set	(&DEBUG, (SYS_CLK / (16 * DEBUG_USART_BAUD_RATE) - 1), 0);
	USART_TX_Enable 	(&DEBUG);
}

/*****************************************************************************************************************************************/
inline void Debug_ch (char ch)
{
	USART_putc (&DEBUG, ch);
}

/*****************************************************************************************************************************************/
inline void dputsP (const char * str)
{
	while (pgm_read_byte(str) != 0x00)
	     Debug_ch(pgm_read_byte(str++));
}

/*****************************************************************************************************************************************/
inline void Debug_u8 (uint8_t u8)
{
	USART_putc (&DEBUG, 0x30 +  u8 / 100);
	USART_putc (&DEBUG, 0x30 + (u8 % 100) / 10);
	USART_putc (&DEBUG, 0x30 +  u8 % 10);
}

/*****************************************************************************************************************************************/
inline void Debug_i16_left (int16_t s16)
{
	if (s16 < 0)
	{
		USART_putc (&DEBUG, '-');
		s16 = -s16;
	}
	else
		USART_putc (&DEBUG, '+');

	if (s16 >= 10000)
		USART_putc (&DEBUG, 0x30 +  s16 / 10000);
	if (s16 >= 1000)
		USART_putc (&DEBUG, 0x30 + (s16 % 10000) / 1000);
	if (s16 >= 100)
		USART_putc (&DEBUG, 0x30 + (s16 % 1000) / 100);
	if (s16 >= 10)
		USART_putc (&DEBUG, 0x30 + (s16 % 100) / 10);
	USART_putc (&DEBUG, 0x30 +  s16 % 10);
}

/*****************************************************************************************************************************************/
inline void Debug_i16 (int16_t s16)
{
	if (s16 < 0)
	{
		USART_putc (&DEBUG, '-');
		s16 = -s16;
	}
	else
		USART_putc (&DEBUG, '+');

	if (s16 >= 10000)
		USART_putc (&DEBUG, 0x30 +  s16 / 10000);
	else
		USART_putc (&DEBUG, ' ');
	if (s16 >= 1000)
		USART_putc (&DEBUG, 0x30 + (s16 % 10000) / 1000);
	else
			USART_putc (&DEBUG, ' ');
	if (s16 >= 100)
		USART_putc (&DEBUG, 0x30 + (s16 % 1000) / 100);
	else
			USART_putc (&DEBUG, ' ');
	if (s16 >= 10)
		USART_putc (&DEBUG, 0x30 + (s16 % 100) / 10);
	else
			USART_putc (&DEBUG, ' ');
	USART_putc (&DEBUG, 0x30 +  s16 % 10);
}














