/*
 * debug.h
 *
 *  Created on: 07.10.2010
 *      Author: mkriegel
 */

#ifndef DEBUG_H_
#define DEBUG_H_

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "m_usart.h"
#include "tricopter_config.h"

// Function macro to send debug string (string will be save in flash memory)
#define		Debug_Str(_str)			( dputsP (PSTR(_str)) )

void InitDebugUSART ();										// Function to init serial port (port and baudrate defined in tricopter_config.h)

void Debug_ch (char ch);									// Debug a char
void Debug_u8   (uint8_t u8);								// Debug a uint8_t
void Debug_i16_left  (int16_t s16);							// Debug a int16_t (left aligned)
void Debug_i16  (int16_t s16);								// Debug a int16_t (eq. %5d alignment)

void dputsP (const char * str);								// String (from program memory) output function over USART


#endif /* DEBUG_H_ */
