/*
 * m_clock.c
 *
 *  Created on: 12.10.2010
 *      Author: mkriegel
 */

#include "m_clock.h"


void InitMainClock ()
{
	// Enable external oscillator frequency from 12 - 16 MHz and enable crystal oscillator selection (startup time 256 CLKs)
	OSC.XOSCCTRL = (uint8_t) OSC_FRQRANGE_12TO16_gc | OSC_XOSCSEL_XTAL_256CLK_gc;

	// Enable configured oscillator as PLL input source and set PLL multiplier
	OSC.PLLCTRL = OSC_PLLSRC_XOSC_gc | (PLL_MULTIPLIER & OSC_PLLFAC_gm);

	// enable external oscillator
	OSC.CTRL |= OSC_XOSCEN_bm;

	// Wait for clock to stabilize
	while ( !(OSC.STATUS & OSC_XOSCRDY_bm) ) {};

	// Enable the PLL
	OSC.CTRL |= OSC_PLLEN_bm;

	// Wait for clock to stabilize
	while ( !(OSC.STATUS & OSC_PLLRDY_bm) ) {};

	// Set PLL as main clock source
	CCP = CCP_IOREG_gc;
	CLK.CTRL = CLK_SCLKSEL_PLL_gc;
}
