/*
 * m_twi.c
 *
 *  Created on: 08.10.2010
 *      Author: mkriegel
 */

#include "m_twi.h"


/*****************************************************************************************************************************************/
// Send TWI start condition and device address
inline void TWI_START(TWI_t * _twi, uint8_t address)
{
#if (TWI_DEBUGGING == 1)
	Debug_Str ("TWI_START: ");
	Debug_u8(address);
	Debug_ch('\n');
#endif
	// Start action + write LIS_ADDRESS address
	_twi->MASTER.ADDR = address;
}


/*****************************************************************************************************************************************/
// Write TWI data
inline void TWI_WRITE(TWI_t * _twi, uint8_t data)
{
#if (TWI_DEBUGGING == 1)
	Debug_Str  ("TWI_WRITE: ");
	Debug_u8(data);
	Debug_ch('\n');
#endif
	// Write TWI data
	_twi->MASTER.DATA = data;
}

/*****************************************************************************************************************************************/
// Send TWI ACK and continue
inline void TWI_ACK(TWI_t * _twi)
{
#if (TWI_DEBUGGING == 1)
	Debug_Str ("TWI_ACK\n");
#endif
	_twi->MASTER.CTRLC = TWI_MASTER_CMD_RECVTRANS_gc;
}

/*****************************************************************************************************************************************/
// Send TWI NACK and stop condition
inline void TWI_NACK_STOP(TWI_t * _twi)
{
#if (TWI_DEBUGGING == 1)
	Debug_Str ("TWI_NACK_STOP\n");
#endif
	_twi->MASTER.CTRLC = TWI_MASTER_ACKACT_bm | TWI_MASTER_CMD_STOP_gc;
}


/*****************************************************************************************************************************************/
// Send TWI stop condition
inline void TWI_STOP(TWI_t * _twi)
{
#if (TWI_DEBUGGING == 1)
	Debug_Str ("---TWI_STOP---\n");
#endif
	_twi->MASTER.CTRLC = TWI_MASTER_CMD_STOP_gc;
}



















