/*
 * m_twi.h
 *
 *  Created on: 08.10.2010
 *      Author: mkriegel
 */

#ifndef M_TWI_H_
#define M_TWI_H_

#include "debug.h"

// TWI defines
#define		I2C_WRITE 		0
#define		I2C_READ		1

// Macros
#define		TWI_BAUD(FCPU, FTWI) 		((FCPU / (2 * FTWI)) - 5)

// Function prototypes
void		TWI_START		(TWI_t * _twi, uint8_t address);
void		TWI_WRITE		(TWI_t * _twi, uint8_t data);
void		TWI_ACK			(TWI_t * _twi);
void		TWI_NACK_STOP	(TWI_t * _twi);
void		TWI_STOP		(TWI_t * _twi);

typedef enum
{
	FUNC_NON_BLOCKING = 0,
	FUNC_BLOCKING
} E_TWI_BLOCKING_TYPE;

#endif /* M_TWI_H_ */
