/*
 * m_usart.h
 *
 *  Created on: 05.10.2010
 *      Author: mkriegel
 */

#ifndef M_USART_H_
#define M_USART_H_

#include <avr/io.h>

// Enable USART receiver
#define		USART_RX_Enable(_usart)				( (_usart)->CTRLB |= USART_RXEN_bm )
// Disable USART receiver
#define		USART_RX_Disable(_usart)			( (_usart)->CTRLB &= ~USART_RXEN_bm )
// Enable USART transmitter
#define		USART_TX_Enable(_usart)				( (_usart)->CTRLB |= USART_TXEN_bm )
// Disable USART transmitter
#define		USART_TX_Disable(_usart)			( (_usart)->CTRLB &= ~USART_TXEN_bm )
// Set USART baudrate
#define		USART_Baudrate_Set(_usart, _bselValue, _bScaleFactor)	\
												(_usart)->BAUDCTRLA = (uint8_t)_bselValue;	\
												(_usart)->BAUDCTRLB = (_bScaleFactor << USART_BSCALE0_bp) | (_bselValue >> 8)

#define USART_Format_Set(_usart, _mode, _charSize, _parityMode, _twoStopBits) \
												(_usart)->CTRLC = \
												(uint8_t) _mode | \
												(uint8_t) _charSize | \
												_parityMode | \
												(_twoStopBits ? USART_SBMODE_bm : 0)


// Function prototypes
void USART_putc (USART_t * _usart, char ch);
void USART_puts (USART_t * _usart, char * string);


#endif /* M_USART_H_ */

















