/*
 * main.c
 *
 *  Created on: 07.10.2010
 *      Author: mkriegel
 */

#include "main.h"

/*****************************************************************************************************************************************/
void wait(uint32_t ws)
{
	while (ws--)
		asm volatile ("nop");
}


/*****************************************************************************************************************************************/
int main(void)
{
	// LA diagnosis
	PORTD.DIRSET = (1 << PIN0);

	PORTE.DIRSET = (1 << PIN3);
	PORTE.OUTCLR = (1 << PIN3);

	PORTF.DIRSET = (1 << PIN6);
	PORTF.OUTCLR = (1 << PIN6);

	LED_BLUE_INIT;																			// INIT blue LED

	InitMainClock ();																		// Init main clock

	_delay_ms (200);																		// Wait a bit for clock to settle and sensors to start up

	PMIC_EnableInterruptLevel(PMIC_HILVLEN_bm | PMIC_MEDLVLEN_bm | PMIC_LOLVLEN_bm);		// Enable interrupt levels in PMIC

	InitDebugUSART();																		// Init Debug port (USART)

	Debug_Str ("*****************************************************\n");
	Debug_Str ("STARTING FLIGHTCONTROL\n\n");

	PMIC_EnableInterruptLevel(PMIC_HILVLEN_bm | PMIC_MEDLVLEN_bm | PMIC_LOLVLEN_bm);		// Enable interrupt levels in PMIC

	sei ();																					// Globally enable interrupts

	if (Init_ITG_Sensor () != 1)															// Init ITG sensor and port
	{
		Debug_Str ("ERROR initializing ITG sensor ...\n");
		return 0;
	}

	if (Init_LIS_Sensor () != 1)															// Init LIS sensor and port
	{
		Debug_Str ("ERROR initializing LIS sensor ...\n");
		return 0;
	}

	Debug_Str ("start lis\n");																// Debug output
	Start_LIS_Data_Query ();																// Start accelerometer query

	Debug_Str ("start itg\n");																// Debug output
	StartITGDataQuery();																	// Start gyro query

	// Main loop --------------------------------------------------------------------------------------------------
	for (;;)
	{
		FlightControl ();
	}

	// Never reached
	return 0;
}












