/*
 * tricopter_config.h
 *
 *  Created on: 06.10.2010
 *      Author: mkriegel
 */

#ifndef TRICOPTER_CONFIG_H_
#define TRICOPTER_CONFIG_H_

// LED DEFINES
// Blue LED
#define		LED_BLUE_PORT					PORTF
#define		LED_BLUE_PIN					PIN7
#define		LED_BLUE_INIT					(PORTF.DIRSET = (1 << LED_BLUE_PIN))		// do not change !!!
#define		LED_BLUE_ON						(PORTF.OUTSET = (1 << LED_BLUE_PIN))		// do not change !!!
#define		LED_BLUE_OFF					(PORTF.OUTCLR = (1 << LED_BLUE_PIN))		// do not change !!!
#define		LED_BLUE_TOGGLE					(PORTF.OUTTGL = (1 << LED_BLUE_PIN))		// do not change !!!

// SYSTEM DEFINES
#define		PLL_MULTIPLIER					2UL
#define		XOSC_FREQUENCY					14745600UL
#define		SYS_CLK							(XOSC_FREQUENCY * PLL_MULTIPLIER)

// FLIGHT CONTROL DEFINES
#define		CONTROL_FREQUENCY_HZ			100L

// LOGGING DEFINES
#define		LOGGING_ENABLED					1
#define		LOGGING_FREQUENCY_HZ			10
#define		LOGGING_PORT					USARTC0

// DEBUG DEFINES
#define		DEBUG_PORT						PORTC
#define		DEBUG							USARTC0
#define		DEBUG_USART_BAUD_RATE			115200UL
// ERRROR DEBUGGING DEFINES
#define		TWI_DEBUGGING					0
#define		LIS_DEBUGGING					0
#define		LIS_ERROR_DEBUGGING				1
#define		ITG_DEBUGGING					0
#define		ITG_ERROR_DEBUGGING				1

// LIS3LV02DQ accelerometer DEFINES
#define		LIS_PORT						PORTF
#define		LIS_TWI_PORT					TWIF
#define		LIS_TWI_INT						TWIF_TWIM_vect
#define		LIS_UPDATE_TIMER				TCF0
#define		LIS_UPDATE_TIMER_INT			TCF0_OVF_vect
#define		LIS_UPDATE_FREQUENCY_HZ			100UL
#define		LIS_TWI_FREQENCY_HZ				400000UL

// ITG-3200 gyro DEFINES
#define		ITG_PORT						PORTE								// XMega port (global) where ITG sensor is connected to
#define		ITG_TWI_PORT					TWIE								// TWI port, where ITG sensor is connected
#define		ITG_TWI_INT						TWIE_TWIM_vect						// TWI interrupt (port specific)
#define		ITG_TWI_FREQUENCY_HZ			400000UL							// TWI frequency
#define		ITG_SAMPLE_RATE_HZ				100UL								// Sample rate of ITG sensor
#define		ITG_QUERY_WITH_TIMER			0									// 0 = query sensor when it gives an interrupt --- 1 = query sensor with timer
// Choose ITG-3200 sensor data query (0 = interrupt based (recommended!), 1 = timer based)
#if (ITG_QUERY_WITH_TIMER == 0)
	#define		ITG_INT_PORT				PORTE								// specify port where ITG interrupt line is connected
	#define		ITG_INT_ISR_VECTOR			PORTE_INT0_vect
	#define		ITG_INT_PIN					PIN2								// specify pin where ITG interrupt line is connected
#else
	#define		ITG_UPDATE_TIMER			TCC0								// Timer for ITG sensor query (unused if ITG_QUERY_WITH_TIMER = 0)
	#define		ITG_UPDATE_TIMER_INT		TCC0_OVF_vect						// Timer overflow interrupt (timer specific)
	#define		ITG_UPDATE_FREQUENCY_HZ		400UL								// Timer update rate
#endif




#endif /* TRICOPTER_CONFIG_H_ */























